//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Bright.h"
#include <math.h>
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TBrightDlg *BrightDlg;
//--------------------------------------------------------------------- 
__fastcall TBrightDlg::TBrightDlg(TComponent* AOwner)
	: TForm(AOwner)
{
}
//---------------------------------------------------------------------
void __fastcall TBrightDlg::FormShow(TObject *Sender)
{
        channel = 3;
        channels[3].Brightness = 0;
        channels[3].Contrast = 0;
        channels[3].k = 1;
        channels[3].b = 0;
        UpdateRGB();
        BrightTrack->Position = 0;
        ContTrack->Position = 0;
        BrightEdit->Text = "0";
        ContEdit->Text = "0";
}
//---------------------------------------------------------------------------
void __fastcall TBrightDlg::BrightTrackChange(TObject *Sender)
{
        int p = BrightTrack->Position;
        channels[channel].Brightness = p;
        BrightEdit->Text = p;
        channels[channel].b = channels[channel].Brightness * 256 / 100;
        UpdateRGB();
        DrawGraph();
}
//---------------------------------------------------------------------------
void __fastcall TBrightDlg::ContTrackChange(TObject *Sender)
{
        int p = ContTrack->Position;
        channels[channel].Contrast = p;
        ContEdit->Text = p;
        if (channels[channel].Contrast == 100)
                channels[channel].k = 256;
        else
                channels[channel].k = tan(M_PI / 2 * (channels[channel].Contrast + 100) * 0.005);
        UpdateRGB();
        DrawGraph();
}
//---------------------------------------------------------------------------
void __fastcall TBrightDlg::BrightEditChange(TObject *Sender)
{
        int p;
        try
        {
                p = StrToInt(BrightEdit->Text);
        }
        catch (EConvertError &e)
        {
                p = 0;
        }
        if (p < -100 || p > 100) p = 0;
        if (BrightTrack->Position == p) return;
        BrightTrack->Position = p;
}
//---------------------------------------------------------------------------
void __fastcall TBrightDlg::ContEditChange(TObject *Sender)
{
        int p;
        try
        {
                p = StrToInt(ContEdit->Text);
        }
        catch (EConvertError &e)
        {
                p = 0;
        }
        if (p < -100 || p > 100) p = 0;
        if (ContTrack->Position == p) return;
        ContTrack->Position = p;
}
//---------------------------------------------------------------------------
void __fastcall TBrightDlg::ChannelsClick(TObject *Sender)
{
        channel = Channels->ItemIndex;
        BrightTrack->Position = channels[channel].Brightness;
        ContTrack->Position = channels[channel].Contrast;
        UpdateRGB();
        DrawGraph();
}
//---------------------------------------------------------------------------
void __fastcall TBrightDlg::FormPaint(TObject *Sender)
{
        DrawGraph();
}
//---------------------------------------------------------------------------
void __fastcall TBrightDlg::DrawGraph()
{
        int b_ = channels[channel].b >> 1;
        float k = channels[channel].k;
        int sx1 = Shape->Left, sx2 = sx1 + Shape->Width;
        int sy1 = Shape->Top, sy2 = sy1 + Shape->Height;
        int cy = (sy1 + sy2) >> 1;
        int y1 = k * 64 - b_ + cy;
        int y2 = k * -64 - b_ + cy;
        int x1 = sx1, x2 = sx2;

        if (y1 > sy2 && k)
        {
                x1 = (y1 - sy2) / k + sx1;
                y1 = sy2;
        }
        if (y2 < sy1 && k)
        {
                x2 = sx2 - (sy1 - y2) / k;
                y2 = sy1;
        }

        Canvas->Pen->Color = clBlack;
        Canvas->Rectangle(sx1, sy1, sx2 + 1, sy2 + 1);
        if (!((y2 > sy2) || (y1 < sy1)))
        {
                Canvas->MoveTo(x1, y1);
                switch (channel)
                {
                        case 0: Canvas->Pen->Color = clRed; break;
                        case 1: Canvas->Pen->Color = clGreen; break;
                        case 2: Canvas->Pen->Color = clBlue; break;
                }
                Canvas->LineTo(x2, y2);
        }
}
void __fastcall TBrightDlg::UpdateRGB()
{
        if (channel == 3)
        for (int i = 0; i < 3; i++)
                memcpy(channels + i, channels + 3, sizeof(ChannelInfo));
}

